## libstxxl 1.3.1

=== Makefile ===
# This -*- Makefile -*- gets processed with both GNU make and nmake.
# So keep it simple and compatible.

############################################################################
#  Makefile
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2002-2007 Roman Dementiev <dementiev@mpi-sb.mpg.de>
#  Copyright (C) 2006 Johannes Singler <singler@ira.uka.de>
#  Copyright (C) 2007-2010 Andreas Beckmann <beckmann@cs.uni-frankfurt.de>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################


usage:
	@echo "Choose one of the goals:"
	@echo "    config_gnu"
	@echo "    library_g++ library_g++_pmode library_g++_mcstl library_icpc library_icpc_mcstl library_msvc"
	@echo "    tests_g++   tests_g++_pmode   tests_g++_mcstl   tests_icpc   tests_icpc_mcstl   tests_msvc"
	@echo "    clean_g++   clean_g++_pmode   clean_g++_mcstl   clean_icpc   clean_icpc_mcstl   clean_msvc"
	@echo "    doxy clean_doxy  tutorial clean_tutorial  examples clean_examples"

settings_gnu:
	cmp -s make.settings.gnu make.settings || \
		( $(RM) make.settings && cp make.settings.gnu make.settings )

settings_msvc: make.settings

make.settings: make.settings.msvc
	copy make.settings.msvc make.settings


config_gnu: settings_gnu
	$(MAKE) -f Makefile.gnu config STXXL_AUTOCONFIG=true


_library_g++: settings_gnu
	$(MAKE) -f Makefile.gnu library

library_g++: _library_g++
	$(MAKE) -f Makefile.gnu library_utils USE_PMODE=no USE_MCSTL=no

library_g++_pmode: _library_g++
	$(MAKE) -f Makefile.gnu library_utils USE_PMODE=yes USE_MCSTL=no

library_g++_mcstl: _library_g++
	$(MAKE) -f Makefile.gnu library_utils USE_PMODE=no USE_MCSTL=yes

_library_icpc: settings_gnu
	$(MAKE) -f Makefile.gnu library USE_ICPC=yes

library_icpc: _library_icpc
	$(MAKE) -f Makefile.gnu library_utils USE_PMODE=no USE_MCSTL=no USE_ICPC=yes

library_icpc_pmode: _library_icpc
	$(MAKE) -f Makefile.gnu library_utils USE_PMODE=yes USE_MCSTL=no USE_ICPC=yes

library_icpc_mcstl: _library_icpc
	$(MAKE) -f Makefile.gnu library_utils USE_PMODE=no USE_MCSTL=yes USE_ICPC=yes

library_msvc: settings_msvc
	nmake /NOLOGO /F Makefile.msvc library


tests_g++: library_g++
	$(MAKE) -f Makefile.gnu tests USE_PMODE=no USE_MCSTL=no

tests_g++_pmode: library_g++_pmode
	$(MAKE) -f Makefile.gnu tests USE_PMODE=yes USE_MCSTL=no

tests_g++_mcstl: library_g++_mcstl
	$(MAKE) -f Makefile.gnu tests USE_PMODE=no USE_MCSTL=yes

tests_icpc: library_icpc
	$(MAKE) -f Makefile.gnu tests USE_PMODE=no USE_MCSTL=no USE_ICPC=yes

tests_icpc_pmode: library_icpc_pmode
	$(MAKE) -f Makefile.gnu tests USE_PMODE=yes USE_MCSTL=no USE_ICPC=yes

tests_icpc_mcstl: library_icpc_mcstl
	$(MAKE) -f Makefile.gnu tests USE_PMODE=no USE_MCSTL=yes USE_ICPC=yes

tests_msvc: settings_msvc
	nmake /NOLOGO /F Makefile.msvc tests


clean_g++: settings_gnu
	$(MAKE) -f Makefile.gnu clean USE_PMODE=no USE_MCSTL=no

clean_g++_pmode: settings_gnu
	-$(MAKE) -f Makefile.gnu clean USE_PMODE=yes USE_MCSTL=no

clean_g++_mcstl: settings_gnu
	-$(MAKE) -f Makefile.gnu clean USE_PMODE=no USE_MCSTL=yes

clean_icpc: settings_gnu
	$(MAKE) -f Makefile.gnu clean USE_PMODE=no USE_MCSTL=no USE_ICPC=yes

clean_icpc_pmode: settings_gnu
	-$(MAKE) -f Makefile.gnu clean USE_PMODE=yes USE_MCSTL=no USE_ICPC=yes

clean_icpc_mcstl: settings_gnu
	-$(MAKE) -f Makefile.gnu clean USE_PMODE=no USE_MCSTL=yes USE_ICPC=yes

clean_msvc: settings_msvc
	nmake /NOLOGO /F Makefile.msvc clean


clean: clean_g++ clean_g++_mcstl clean_icpc clean_icpc_mcstl
	$(MAKE) -C test/compile-stxxl-headers clean

distclean: clean_doxy clean_tutorial clean_examples clean
	$(RM) make.settings
	$(RM) stxxl.log stxxl.errlog
	$(RM) algo/stxxl.log algo/stxxl.errlog
	$(RM) common/stxxl.log common/stxxl.errlog
	$(RM) containers/stxxl.log containers/stxxl.errlog
	$(RM) io/stxxl.log io/stxxl.errlog
	$(RM) mng/stxxl.log mng/stxxl.errlog
	$(RM) stream/stxxl.log stream/stxxl.errlog
	$(RM) utils/stxxl.log utils/stxxl.errlog


doxy: Doxyfile
	doxygen

clean_doxy:
	$(RM) -r doc/doxy
	$(RM) Doxyfile.bak

tutorial:
	$(MAKE) -C doc/tutorial

clean_tutorial:
	$(MAKE) -C doc/tutorial distclean

examples:
	$(MAKE) -C doc/tutorial/examples

clean_examples:
	$(MAKE) -C doc/tutorial/examples clean

count:
	sloccount --addlang makefile .

# optional parameters:
# DATE=""     if you *don't* want a -YYYYMMDD in the version
# PHASE=snapshot|alpha#|beta#|rc#|release    (defaults to snapshot)
release:
	$(MAKE) -f Makefile.gnu release

=== algo/Makefile ===
include Makefile.common
include ../make.settings

tests: $(TESTS)
#tests: $(TESTS_LONG_COMPILE)
#tests: $(TESTS_NON_MSVC)

lib: async_schedule.$(OBJEXT)


async_schedule.$(OBJEXT): async_schedule.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c async_schedule.cpp


DEPENDENCIES = $(COMMON_FILES) $(IO_LAYER_FILES) $(MNG_LAYER_FILES) $(CONTAINER_FILES) $(ALGO_FILES)


test_sort: test_sort.$(EXEEXT)
test_sort.$(EXEEXT): test_sort.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_sort.cpp -DSTXXL_VERBOSE_LEVEL=0
	$(LINKER)  test_sort.$(OBJEXT) $(OUT)test_sort.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_sort_all_parameters: test_sort_all_parameters.$(EXEEXT)
test_sort_all_parameters.$(EXEEXT): test_sort_all_parameters.cpp # takes long to compile
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_sort_all_parameters.cpp 
	$(LINKER)  test_sort_all_parameters.$(OBJEXT) $(OUT)test_sort_all_parameters.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_ksort: test_ksort.$(EXEEXT)
test_ksort.$(EXEEXT): test_ksort.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_ksort.cpp -DSTXXL_CHECK_ORDER_IN_SORTS
	$(LINKER)  test_ksort.$(OBJEXT) $(OUT)test_ksort.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_ksort_all_parameters: test_ksort_all_parameters.$(EXEEXT)
test_ksort_all_parameters.$(EXEEXT): test_ksort_all_parameters.cpp $(DEPENDENCIES) # takes long to compile 
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_ksort_all_parameters.cpp
	$(LINKER)  test_ksort_all_parameters.$(OBJEXT) $(OUT)test_ksort_all_parameters.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_stable_ksort: test_stable_ksort.$(EXEEXT)
test_stable_ksort.$(EXEEXT): test_stable_ksort.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_stable_ksort.cpp
	$(LINKER)  test_stable_ksort.$(OBJEXT) $(OUT)test_stable_ksort.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_stable_ksort_all_parameters: test_stable_ksort_all_parameters.$(EXEEXT)
test_stable_ksort_all_parameters.$(EXEEXT): test_stable_ksort_all_parameters.cpp $(DEPENDENCIES) # takes long to compile
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_stable_ksort_all_parameters.cpp
	$(LINKER)  test_stable_ksort_all_parameters.$(OBJEXT) $(OUT)test_stable_ksort_all_parameters.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

sort_file: sort_file.$(EXEEXT)
sort_file.$(EXEEXT): sort_file.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c sort_file.cpp
	$(LINKER)  sort_file.$(OBJEXT) $(OUT)sort_file.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

copy_and_sort_file: copy_and_sort_file.$(EXEEXT)
copy_and_sort_file.$(EXEEXT): copy_and_sort_file.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c copy_and_sort_file.cpp
	$(LINKER) copy_and_sort_file.$(OBJEXT) $(OUT)copy_and_sort_file.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_asch: test_asch.$(EXEEXT)
test_asch.$(EXEEXT): test_asch.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_asch.cpp
	$(LINKER)  test_asch.$(OBJEXT) $(OUT)test_asch.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_scan: test_scan.$(EXEEXT)
test_scan.$(EXEEXT): test_scan.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_scan.cpp
	$(LINKER)  test_scan.$(OBJEXT) $(OUT)test_scan.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

gen_file: gen_file.$(EXEEXT)
gen_file.$(EXEEXT): gen_file.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c gen_file.cpp
	$(LINKER)  gen_file.$(OBJEXT) $(OUT)gen_file.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_random_shuffle: test_random_shuffle.$(EXEEXT)
test_random_shuffle.$(EXEEXT): test_random_shuffle.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_random_shuffle.cpp -DSTXXL_VERBOSE_LEVEL=0
	$(LINKER)  test_random_shuffle.$(OBJEXT) $(OUT)test_random_shuffle.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_bad_cmp: test_bad_cmp.$(EXEEXT)
test_bad_cmp.$(EXEEXT): test_bad_cmp.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_bad_cmp.cpp -DSTXXL_VERBOSE_LEVEL=0
	$(LINKER)  test_bad_cmp.$(OBJEXT) $(OUT)test_bad_cmp.$(EXEEXT) $(STXXL_LINKER_OPTIONS)


clean:
	$(RM) $(CLEAN_TARGETS)

=== common/Makefile ===
include Makefile.common
include ../make.settings

tools: $(UTIL_BINARIES)

tests: $(TESTS)
#tests: $(TESTS_NON_MSVC)

lib: rand.$(OBJEXT) version.$(OBJEXT) seed.$(OBJEXT) exithandler.$(OBJEXT) verbose.$(OBJEXT) log.$(OBJEXT)


rand.$(OBJEXT): rand.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c rand.cpp

version.$(OBJEXT): version.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c version.cpp

seed.$(OBJEXT): seed.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c seed.cpp

exithandler.$(OBJEXT): exithandler.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c exithandler.cpp

verbose.$(OBJEXT): verbose.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c verbose.cpp

log.$(OBJEXT): log.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c log.cpp


DEPENDENCIES = $(COMMON_FILES) $(IO_LAYER_FILES) $(MNG_LAYER_FILES) $(CONTAINER_FILES) $(ALGO_FILES)


stxxl_info: stxxl_info.$(EXEEXT)
stxxl_info.$(EXEEXT): stxxl_info.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c stxxl_info.cpp
	$(LINKER) stxxl_info.$(OBJEXT) $(OUT)stxxl_info.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_random: test_random.$(EXEEXT)
test_random.$(EXEEXT): test_random.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_random.cpp
	$(LINKER) test_random.$(OBJEXT) $(OUT)test_random.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_manyunits: test_manyunits.$(EXEEXT)
test_manyunits.$(EXEEXT): test_manyunits.cpp test_manyunits2.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_manyunits.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_manyunits2.cpp
	$(LINKER) test_manyunits.$(OBJEXT) test_manyunits2.$(OBJEXT) $(OUT)test_manyunits.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_globals: test_globals.$(EXEEXT)
test_globals.$(EXEEXT): test_globals.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_globals.cpp
	$(LINKER) test_globals.$(OBJEXT) $(OUT)test_globals.$(EXEEXT) $(STXXL_LINKER_OPTIONS)


clean:
	$(RM) $(CLEAN_TARGETS)

=== containers/Makefile ===
include Makefile.common
include ../make.settings

tests: $(TESTS) $(TESTS_MAP)
	cd btree
	$(MAKE) tests
	cd ..
#tests: $(TESTS_NON_MSVC)

NDEBUG		 = #-DNDEBUG

DEPENDENCIES = $(COMMON_FILES) $(IO_LAYER_FILES) $(MNG_LAYER_FILES) $(CONTAINER_FILES)


stack_benchmark: stack_benchmark.$(EXEEXT)
stack_benchmark.$(EXEEXT): stack_benchmark.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c stack_benchmark.cpp $(NDEBUG)
	$(LINKER) stack_benchmark.$(OBJEXT) $(OUT)stack_benchmark.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_iterators: test_iterators.$(EXEEXT)
test_iterators.$(EXEEXT): test_iterators.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_iterators.cpp
	$(LINKER) test_iterators.$(OBJEXT) $(OUT)test_iterators.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_deque: test_deque.$(EXEEXT)
test_deque.$(EXEEXT): test_deque.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_deque.cpp
	$(LINKER) test_deque.$(OBJEXT) $(OUT)test_deque.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

pq_benchmark: pq_benchmark.$(EXEEXT)
pq_benchmark.$(EXEEXT):  pq_benchmark.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c pq_benchmark.cpp $(NDEBUG)
	$(LINKER) pq_benchmark.$(OBJEXT) $(OUT)pq_benchmark.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

write_vector: write_vector.$(EXEEXT)
write_vector.$(EXEEXT): write_vector.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c write_vector.cpp
	$(LINKER) write_vector.$(OBJEXT) $(OUT)write_vector.$(EXEEXT) $(STXXL_LINKER_OPTIONS)
	
write_vector2: write_vector2.$(EXEEXT)
write_vector2.$(EXEEXT): write_vector2.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c write_vector2.cpp
	$(LINKER) write_vector2.$(OBJEXT) $(OUT)write_vector2.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_queue: test_queue.$(EXEEXT)
test_queue.$(EXEEXT): test_queue.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_queue.cpp
	$(LINKER) test_queue.$(OBJEXT) $(OUT)test_queue.$(EXEEXT) $(STXXL_LINKER_OPTIONS)


test_map: test_map.$(EXEEXT)
test_map.$(EXEEXT): test_map.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_map.cpp
	$(LINKER)  test_map.$(OBJEXT) $(OUT)test_map.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_map_random: test_map_random.$(EXEEXT)
test_map_random.$(EXEEXT): test_map_random.cpp map_test_handlers.h $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_map_random.cpp 
	$(LINKER) test_map_random.$(OBJEXT) $(OUT)test_map_random.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

copy_file: copy_file.$(EXEEXT)
copy_file.$(EXEEXT): copy_file.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c copy_file.cpp
	$(LINKER) copy_file.$(OBJEXT) $(OUT)copy_file.$(EXEEXT) $(STXXL_LINKER_OPTIONS)
	

test_vector: test_vector.$(EXEEXT)
test_vector.$(EXEEXT): test_vector.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_vector.cpp
	$(LINKER)  test_vector.$(OBJEXT) $(OUT)test_vector.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_vector_export: test_vector_export.$(EXEEXT)
test_vector_export.$(EXEEXT): test_vector_export.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_vector_export.cpp
	$(LINKER)  test_vector_export.$(OBJEXT) $(OUT)test_vector_export.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_stack: test_stack.$(EXEEXT)
test_stack.$(EXEEXT): test_stack.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_stack.cpp
	$(LINKER)  test_stack.$(OBJEXT) $(OUT)test_stack.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_migr_stack: test_migr_stack.$(EXEEXT)
test_migr_stack.$(EXEEXT): test_migr_stack.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_migr_stack.cpp
	$(LINKER)  test_migr_stack.$(OBJEXT) $(OUT)test_migr_stack.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_many_stacks: test_many_stacks.$(EXEEXT)
test_many_stacks.$(EXEEXT): test_many_stacks.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_many_stacks.cpp -DSTXXL_VERBOSE_LEVEL=1
	$(LINKER)  test_many_stacks.$(OBJEXT) $(OUT)test_many_stacks.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_pqueue: test_pqueue.$(EXEEXT)
test_pqueue.$(EXEEXT): test_pqueue.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_pqueue.cpp
	$(LINKER)  test_pqueue.$(OBJEXT) $(OUT)test_pqueue.$(EXEEXT) $(STXXL_LINKER_OPTIONS) 

test_ext_merger: test_ext_merger.$(EXEEXT)
test_ext_merger.$(EXEEXT): test_ext_merger.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_ext_merger.cpp -DSTXXL_VERBOSE_LEVEL=1
	$(LINKER)  test_ext_merger.$(OBJEXT) $(OUT)test_ext_merger.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_ext_merger2: test_ext_merger2.$(EXEEXT)
test_ext_merger2.$(EXEEXT): test_ext_merger2.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_ext_merger2.cpp -DSTXXL_VERBOSE_LEVEL=1
	$(LINKER)  test_ext_merger2.$(OBJEXT) $(OUT)test_ext_merger2.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

bench_pqueue: bench_pqueue.$(EXEEXT)
bench_pqueue.$(EXEEXT): bench_pqueue.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c bench_pqueue.cpp -DSTXXL_VERBOSE_LEVEL=0
	$(LINKER)  bench_pqueue.$(OBJEXT) $(OUT)bench_pqueue.$(EXEEXT)  $(STXXL_LINKER_OPTIONS)

monotonic_pq: monotonic_pq.$(EXEEXT)
monotonic_pq.$(EXEEXT): monotonic_pq.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c monotonic_pq.cpp
	$(LINKER)  monotonic_pq.$(OBJEXT) $(OUT)monotonic_pq.$(EXEEXT)  $(STXXL_LINKER_OPTIONS)

benchmark_naive_matrix: benchmark_naive_matrix.$(EXEEXT)
benchmark_naive_matrix.$(EXEEXT): benchmark_naive_matrix.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c benchmark_naive_matrix.cpp -DSTXXL_VERBOSE_LEVEL=0
	$(LINKER) benchmark_naive_matrix.$(OBJEXT) $(OUT)benchmark_naive_matrix.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_vector_sizes: test_vector_sizes.$(EXEEXT)
test_vector_sizes.$(EXEEXT): test_vector_sizes.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_vector_sizes.cpp
	$(LINKER) test_vector_sizes.$(OBJEXT) $(OUT)test_vector_sizes.$(EXEEXT) $(STXXL_LINKER_OPTIONS)


clean:
	$(RM) $(CLEAN_TARGETS)
	cd btree
	$(MAKE) clean
	cd ..

=== io/Makefile ===
include Makefile.common
include ../make.settings

tools: $(UTIL_BINARIES)

tests: $(TESTS)
#tests: $(TESTS_NON_MSVC)

lib: ufs_file_base.$(OBJEXT) syscall_file.$(OBJEXT) wincall_file.$(OBJEXT) wfs_file_base.$(OBJEXT) \
iostats.$(OBJEXT) \
mmap_file.$(OBJEXT) simdisk_file.$(OBJEXT) boostfd_file.$(OBJEXT) mem_file.$(OBJEXT) \
fileperblock_file.$(OBJEXT) request.$(OBJEXT) request_with_waiters.$(OBJEXT) \
request_with_state.$(OBJEXT) serving_request.$(OBJEXT) \
disk_queued_file.$(OBJEXT) request_queue_impl_qwqr.$(OBJEXT) request_queue_impl_1q.$(OBJEXT) \
request_queue_impl_worker.$(OBJEXT) wbtl_file.$(OBJEXT) create_file.$(OBJEXT)



ufs_file_base.$(OBJEXT): ufs_file_base.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c ufs_file_base.cpp

syscall_file.$(OBJEXT): syscall_file.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c syscall_file.cpp

wbtl_file.$(OBJEXT): wbtl_file.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c wbtl_file.cpp

wincall_file.$(OBJEXT): wincall_file.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c wincall_file.cpp

wfs_file_base.$(OBJEXT): wfs_file_base.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c wfs_file_base.cpp

iostats.$(OBJEXT): iostats.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c iostats.cpp

mmap_file.$(OBJEXT): mmap_file.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c mmap_file.cpp

simdisk_file.$(OBJEXT): simdisk_file.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c simdisk_file.cpp

boostfd_file.$(OBJEXT): boostfd_file.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c boostfd_file.cpp

mem_file.$(OBJEXT): mem_file.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c mem_file.cpp

fileperblock_file.$(OBJEXT): fileperblock_file.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c fileperblock_file.cpp

request.$(OBJEXT): request.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c request.cpp

request_with_state.$(OBJEXT): request_with_state.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c request_with_state.cpp

request_with_waiters.$(OBJEXT): request_with_waiters.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c request_with_waiters.cpp

serving_request.$(OBJEXT): serving_request.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c serving_request.cpp

disk_queued_file.$(OBJEXT): disk_queued_file.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c disk_queued_file.cpp

request_queue_impl_qwqr.$(OBJEXT): request_queue_impl_qwqr.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c request_queue_impl_qwqr.cpp

request_queue_impl_1q.$(OBJEXT): request_queue_impl_1q.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c request_queue_impl_1q.cpp

request_queue_impl_worker.$(OBJEXT): request_queue_impl_worker.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c request_queue_impl_worker.cpp

create_file.$(OBJEXT): create_file.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c create_file.cpp


DEPENDENCIES = $(COMMON_FILES) $(IO_LAYER_FILES)


test_io: test_io.$(EXEEXT)
test_io.$(EXEEXT): test_io.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_io.cpp
	$(LINKER) test_io.$(OBJEXT) $(OUT)test_io.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_io_sizes: test_io_sizes.$(EXEEXT)
test_io_sizes.$(EXEEXT): test_io_sizes.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_io_sizes.cpp
	$(LINKER) test_io_sizes.$(OBJEXT) $(OUT)test_io_sizes.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_cancel: test_cancel.$(EXEEXT)
test_cancel.$(EXEEXT): test_cancel.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_cancel.cpp
	$(LINKER) test_cancel.$(OBJEXT) $(OUT)test_cancel.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

benchmark_disks: benchmark_disks.$(EXEEXT)
benchmark_disks.$(EXEEXT): benchmark_disks.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c benchmark_disks.cpp  
	$(LINKER) benchmark_disks.$(OBJEXT) $(OUT)benchmark_disks.$(EXEEXT) $(STXXL_LINKER_OPTIONS) 

flushbuffers: flushbuffers.$(EXEEXT)
flushbuffers.$(EXEEXT): flushbuffers.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c flushbuffers.cpp
	$(LINKER) flushbuffers.$(OBJEXT) $(OUT)flushbuffers.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

unittest: unittest.$(EXEEXT)
unittest.$(EXEEXT): unittest.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) $(CPPUNIT_COMPILER_OPTIONS) -c unittest.cpp
	$(LINKER) unittest.$(OBJEXT) $(OUT)unittest.$(EXEEXT) $(STXXL_LINKER_OPTIONS) $(CPPUNIT_LINKER_OPTIONS)

sd_test: sd_test.$(EXEEXT)
sd_test.$(EXEEXT): sd_test.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c sd_test.cpp
	$(LINKER) sd_test.$(OBJEXT) $(OUT)sd_test.$(EXEEXT) $(STXXL_LINKER_OPTIONS) $(CPPUNIT_LINKER_OPTIONS)

gen_file: gen_file.$(EXEEXT)
gen_file.$(EXEEXT): gen_file.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c gen_file.cpp
	$(LINKER) gen_file.$(OBJEXT) $(OUT)gen_file.$(EXEEXT) $(STXXL_LINKER_OPTIONS) $(CPPUNIT_LINKER_OPTIONS)

benchmark_disk_and_flash: benchmark_disk_and_flash.$(EXEEXT)
benchmark_disk_and_flash.$(EXEEXT): benchmark_disk_and_flash.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c benchmark_disk_and_flash.cpp
	$(LINKER) benchmark_disk_and_flash.$(OBJEXT) $(OUT)benchmark_disk_and_flash.$(EXEEXT) $(STXXL_LINKER_OPTIONS) $(CPPUNIT_LINKER_OPTIONS)

benchmark_configured_disks: benchmark_configured_disks.$(EXEEXT)
benchmark_configured_disks.$(EXEEXT): benchmark_configured_disks.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c benchmark_configured_disks.cpp
	$(LINKER) benchmark_configured_disks.$(OBJEXT) $(OUT)benchmark_configured_disks.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

benchmark_random_block_access: benchmark_random_block_access.$(EXEEXT)
benchmark_random_block_access.$(EXEEXT): benchmark_random_block_access.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c benchmark_random_block_access.cpp
	$(LINKER) benchmark_random_block_access.$(OBJEXT) $(OUT)benchmark_random_block_access.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

iobench_scatter_in_place: iobench_scatter_in_place.$(EXEEXT)
iobench_scatter_in_place.$(EXEEXT): iobench_scatter_in_place.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c iobench_scatter_in_place.cpp
	$(LINKER) iobench_scatter_in_place.$(OBJEXT) $(OUT)iobench_scatter_in_place.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

verify_disks: verify_disks.$(EXEEXT)
verify_disks.$(EXEEXT): verify_disks.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c verify_disks.cpp  
	$(LINKER) verify_disks.$(OBJEXT) $(OUT)verify_disks.$(EXEEXT) $(STXXL_LINKER_OPTIONS) 


clean:
	$(RM) $(CLEAN_TARGETS)

=== lib/Makefile ===
include Makefile.common
include ../make.settings

all: lib

tests:

lib: lib$(LIBNAME).$(LIBEXT)
lib$(LIBNAME).$(LIBEXT): $(LIB_OBJECTS)
	del lib$(LIBNAME).$(LIBEXT)
	$(LIBGEN)lib$(LIBNAME).$(LIBEXT) $(LIB_OBJECTS)

clean:
	$(RM) $(CLEAN_TARGETS)

=== mng/Makefile ===
include Makefile.common
include ../make.settings

tests: $(TESTS)
#tests: $(TESTS_NON_MSVC)

lib: mng.$(OBJEXT) config.$(OBJEXT) diskallocator.$(OBJEXT)


mng.$(OBJEXT): mng.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c mng.cpp

config.$(OBJEXT): config.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c config.cpp

diskallocator.$(OBJEXT): diskallocator.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c diskallocator.cpp


DEPENDENCIES = $(COMMON_FILES) $(IO_LAYER_FILES) $(MNG_LAYER_FILES)


test_mng: test_mng.$(EXEEXT)
test_mng.$(EXEEXT): test_mng.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_mng.cpp -DSTXXL_VERBOSE_LEVEL=2 
	$(LINKER) test_mng.$(OBJEXT) $(OUT)test_mng.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_mng1: test_mng1.$(EXEEXT)
test_mng1.$(EXEEXT): test_mng1.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_mng1.cpp -DSTXXL_VERBOSE_LEVEL=2
	$(LINKER) test_mng1.$(OBJEXT) $(OUT)test_mng1.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_buf_streams: test_buf_streams.$(EXEEXT)
test_buf_streams.$(EXEEXT): test_buf_streams.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_buf_streams.cpp
	$(LINKER) test_buf_streams.$(OBJEXT) $(OUT)test_buf_streams.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_block_alloc_strategy: test_block_alloc_strategy.$(EXEEXT)
test_block_alloc_strategy.$(EXEEXT): test_block_alloc_strategy.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_block_alloc_strategy.cpp
	$(LINKER) test_block_alloc_strategy.$(OBJEXT) $(OUT)test_block_alloc_strategy.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_write_pool: test_write_pool.$(EXEEXT)
test_write_pool.$(EXEEXT): test_write_pool.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_write_pool.cpp -DSTXXL_VERBOSE_LEVEL=1
	$(LINKER) test_write_pool.$(OBJEXT) $(OUT)test_write_pool.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_prefetch_pool: test_prefetch_pool.$(EXEEXT)
test_prefetch_pool.$(EXEEXT): test_prefetch_pool.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_prefetch_pool.cpp -DSTXXL_VERBOSE_LEVEL=2
	$(LINKER) test_prefetch_pool.$(OBJEXT) $(OUT)test_prefetch_pool.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_mng_recursive_alloc: test_mng_recursive_alloc.$(EXEEXT)
test_mng_recursive_alloc.$(EXEEXT): test_mng_recursive_alloc.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_mng_recursive_alloc.cpp -DSTXXL_VERBOSE_LEVEL=3
	$(LINKER) test_mng_recursive_alloc.$(OBJEXT) $(OUT)test_mng_recursive_alloc.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_pool_pair: test_pool_pair.$(EXEEXT)
test_pool_pair.$(EXEEXT): test_pool_pair.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_pool_pair.cpp
	$(LINKER) test_pool_pair.$(OBJEXT) $(OUT)test_pool_pair.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_read_write_pool: test_read_write_pool.$(EXEEXT)
test_read_write_pool.$(EXEEXT): test_read_write_pool.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_read_write_pool.cpp
	$(LINKER) test_read_write_pool.$(OBJEXT) $(OUT)test_read_write_pool.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_aligned: test_aligned.$(EXEEXT)
test_aligned.$(EXEEXT): test_aligned.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_aligned.cpp
	$(LINKER) test_aligned.$(OBJEXT) $(OUT)test_aligned.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

unittest: unittest.$(EXEEXT) $(DEPENDENCIES)
unittest.$(EXEEXT): unittest.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) $(CPPUNIT_COMPILER_OPTIONS) -c unittest.cpp
	$(LINKER) unittest.$(OBJEXT) $(OUT)unittest.$(EXEEXT) $(STXXL_LINKER_OPTIONS) $(CPPUNIT_LINKER_OPTIONS)


clean:
	$(RM) $(CLEAN_TARGETS)

=== stream/Makefile ===
include Makefile.common
include ../make.settings

tests: $(TESTS)
#tests: $(TESTS_NON_MSVC)


DEPENDENCIES = $(COMMON_FILES) $(IO_LAYER_FILES) $(MNG_LAYER_FILES) \
               $(CONTAINER_FILES) $(ALGO_FILES) $(STREAM_FILES)


test_stream1: test_stream1.$(EXEEXT)
test_stream1.$(EXEEXT): test_stream1.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_stream1.cpp -DSTXXL_VERBOSE_LEVEL=1
	$(LINKER)  test_stream1.$(OBJEXT) $(OUT)test_stream1.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_sorted_runs: test_sorted_runs.$(EXEEXT)
test_sorted_runs.$(EXEEXT): test_sorted_runs.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_sorted_runs.cpp
	$(LINKER)  test_sorted_runs.$(OBJEXT) $(OUT)test_sorted_runs.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_push_sort: test_push_sort.$(EXEEXT)
test_push_sort.$(EXEEXT): test_push_sort.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_push_sort.cpp
	$(LINKER)  test_push_sort.$(OBJEXT) $(OUT)test_push_sort.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_stream: test_stream.$(EXEEXT)
test_stream.$(EXEEXT): test_stream.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_stream.cpp -DSTXXL_VERBOSE_LEVEL=1
	$(LINKER)  test_stream.$(OBJEXT) $(OUT)test_stream.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_materialize: test_materialize.$(EXEEXT)
test_materialize.$(EXEEXT): test_materialize.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_materialize.cpp -DSTXXL_VERBOSE_LEVEL=1
	$(LINKER)  test_materialize.$(OBJEXT) $(OUT)test_materialize.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_naive_transpose: test_naive_transpose.$(EXEEXT)
test_naive_transpose.$(EXEEXT): test_naive_transpose.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_naive_transpose.cpp
	$(LINKER) test_naive_transpose.$(OBJEXT) $(OUT)test_naive_transpose.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_loop: test_loop.$(EXEEXT)
test_loop.$(EXEEXT): test_loop.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_loop.cpp
	$(LINKER) test_loop.$(OBJEXT) $(OUT)test_loop.$(EXEEXT) $(STXXL_LINKER_OPTIONS)


clean:
	$(RM) $(CLEAN_TARGETS)

=== utils/Makefile ===
include Makefile.common
include ../make.settings

tools: $(UTIL_BINARIES)

tests: $(TESTS)
#tests: $(TESTS_NON_MSVC)

NDEBUG		 = #-DNDEBUG
DEPENDENCIES = $(COMMON_FILES) $(IO_LAYER_FILES) $(MNG_LAYER_FILES) $(CONTAINER_FILES) $(ALGO_FILES)

createdisks: createdisks.$(EXEEXT)
createdisks.$(EXEEXT): createdisks.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c createdisks.cpp $(NDEBUG)
	$(LINKER) createdisks.$(OBJEXT) $(OUT)createdisks.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

malloc: malloc.$(EXEEXT)
malloc.$(EXEEXT): malloc.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c malloc.cpp $(NDEBUG)
	$(LINKER) malloc.$(OBJEXT) $(OUT)malloc.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

pq_param: pq_param.$(EXEEXT)
pq_param.$(EXEEXT): pq_param.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c pq_param.cpp $(NDEBUG)
	$(LINKER) pq_param.$(OBJEXT) $(OUT)pq_param.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

log2: log2.$(EXEEXT)
log2.$(EXEEXT): log2.cpp $(DEPENDENCIES)
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c log2.cpp $(NDEBUG)
	$(LINKER) log2.$(OBJEXT) $(OUT)log2.$(EXEEXT) $(STXXL_LINKER_OPTIONS)


clean:
	$(RM) $(CLEAN_TARGETS)

=== containers/btree/Makefile ===
include ../Makefile.common
include ../../make.settings

tests: $(TESTS_BTREE)

# DEPENDENCIES = $(DEPENDENCIES)  btree.h leaf.h iterator.h iterator_map.h node_cache.h

STXXL_COMPILER_OPTIONS = $(STXXL_COMPILER_OPTIONS) -DSTXXL_VERBOSE_LEVEL=0

test_const_scan: test_const_scan.$(EXEEXT)
test_const_scan.$(EXEEXT): $(DEPENDENCIES) test_const_scan.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_const_scan.cpp
	$(LINKER) test_const_scan.$(OBJEXT) $(OUT)test_const_scan.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_corr_insert_erase: test_corr_insert_erase.$(EXEEXT)
test_corr_insert_erase.$(EXEEXT): $(DEPENDENCIES) test_corr_insert_erase.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_corr_insert_erase.cpp
	$(LINKER) test_corr_insert_erase.$(OBJEXT) $(OUT)test_corr_insert_erase.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_corr_insert_find: test_corr_insert_find.$(EXEEXT)
test_corr_insert_find.$(EXEEXT): $(DEPENDENCIES) test_corr_insert_find.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_corr_insert_find.cpp
	$(LINKER) test_corr_insert_find.$(OBJEXT) $(OUT)test_corr_insert_find.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_corr_insert_scan: test_corr_insert_scan.$(EXEEXT)
test_corr_insert_scan.$(EXEEXT): $(DEPENDENCIES) test_corr_insert_scan.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_corr_insert_scan.cpp
	$(LINKER) test_corr_insert_scan.$(OBJEXT) $(OUT)test_corr_insert_scan.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

test_btree: test_btree.$(EXEEXT)
test_btree.$(EXEEXT): $(DEPENDENCIES) test_btree.cpp
	$(COMPILER) $(STXXL_COMPILER_OPTIONS) -c test_btree.cpp
	$(LINKER) test_btree.$(OBJEXT) $(OUT)test_btree.$(EXEEXT) $(STXXL_LINKER_OPTIONS)

clean:
	$(RM) $(CLEAN_TARGETS)

=== doc/tutorial/Makefile ===
all: tutorial

tutorial: tutorial.pdf

# try to use rules from LaTeX.mk (from latex-utils package)
-include LaTeX.mk

ifeq (,$(LU_UTILS))
# if LaTeX.mk is not available, fallback to our own rules

tutorial.pdf: tutorial.tex tutorial.bib
	pdflatex tutorial
	bibtex tutorial
	pdflatex tutorial
	pdflatex tutorial

clean:
	rm -rf *.bbl *.aux *~ *.dvi *.log *.toc *.blg *.idx

distclean: clean
	$(RM) tutorial.pdf

.PHONY: clean

endif


spell:
	ispell -d american tutorial.tex

.PHONY: all tutorial spell

=== test/compile-stxxl-headers/Makefile ===
############################################################################
#  test/compile-stxxl-headers/Makefile
#
#  Part of the STXXL. See http://stxxl.sourceforge.net
#
#  Copyright (C) 2007 Andreas Beckmann <beckmann@mpi-inf.mpg.de>
#
#  Distributed under the Boost Software License, Version 1.0.
#  (See accompanying file LICENSE_1_0.txt or copy at
#  http://www.boost.org/LICENSE_1_0.txt)
############################################################################

INSTANCE	?= stxxl
INSTANCE	?= pmstxxl
INSTANCE	?= mcstxxl

TOPDIR		?= ../..
include $(TOPDIR)/make.settings
-include $(TOPDIR)/$(INSTANCE).mk

CXX		 = $(STXXL_CXX)
OPT		 = -O3
WARNINGS	 = $(STXXL_WARNFLAGS)
DEBUG		 = $(STXXL_DEBUGFLAGS)

CPPFLAGS	+= -I$(TOPDIR)/include
CPPFLAGS	+= $(STXXL_CPPFLAGS)
CPPFLAGS	+= $(OPT) $(DEBUG) $(WARNINGS)
CPPFLAGS	+= -MD

STXXL_MAIN_HEADER	+= stxxl.h
STXXL_HEADERS		+= all
STXXL_HEADERS		+= vector stack queue priority_queue deque map
STXXL_HEADERS		+= algorithm scan sort ksort stable_ksort random_shuffle
STXXL_HEADERS		+= io mng stream
STXXL_HEADERS		+= random timer mallocstats aligned_alloc types stats
STXXL_BITS		+= $(HEADER_FILES_BITS)
STXXL_BITS		+= $(HEADER_FILES_COMMON:%=common/%)
STXXL_BITS		+= $(HEADER_FILES_COMPAT:%=compat/%)
STXXL_BITS		+= $(HEADER_FILES_IO:%=io/%)
STXXL_BITS		+= $(HEADER_FILES_MNG:%=mng/%)
STXXL_BITS		+= $(HEADER_FILES_CONTAINERS:%=containers/%)
STXXL_BITS		+= $(HEADER_FILES_CONTAINERS_BTREE:%=containers/btree/%)
STXXL_BITS		+= $(HEADER_FILES_ALGO:%=algo/%)
STXXL_BITS		+= $(HEADER_FILES_STREAM:%=stream/%)
STXXL_BITS		+= $(HEADER_FILES_UTILS:%=utils/%)
HEADERS			 = $(STXXL_MAIN_HEADER) $(STXXL_HEADERS:%=stxxl/%) $(STXXL_BITS:%=stxxl/bits/%)
HEADERS_ESCAPED		 = $(subst /,~,$(HEADERS))


#all: preprocess-test
all: compile-test

preprocess-test: $(HEADERS_ESCAPED:%=test-header-%.$(INSTANCE).ii)
compile-test: $(HEADERS_ESCAPED:%=test-header-%.$(INSTANCE).o)

test-header-%.th.cpp::
	echo '#include "$(subst ~,/,$*)"' > $@

%.$(INSTANCE).ii: %.th.cpp
	$(CXX) $(CPPFLAGS) -E $< -o $@

%.$(INSTANCE).o: %.th.cpp $(wildcard ../../$(INSTANCE).mk)
	$(COMPILE.cc) $(OUTPUT_OPTION) $<

clean:
	$(RM) *.ii *.o *.d *.dT
	$(RM) test-header-*.cpp


.SECONDARY:

-include *.d

=== debian/changelog ===
libstxxl (1.3.1-5ubuntu1) trusty; urgency=low

  * Resolve FTBFS from extra build infrastructure command

 -- Daniel T Chen <crimsun@ubuntu.com>  Tue, 12 Nov 2013 17:01:58 -0500

libstxxl (1.3.1-5) unstable; urgency=low

  * Apply doxygen SVG output patch (Closes: #721261)
  * Enable hardening during build
  * Update uploader email

 -- D Haley <mycae@gmx.com>  Fri, 30 Aug 2013 22:34:04 +0200

libstxxl (1.3.1-4) unstable; urgency=low

  * Remove ICPC compat header (Closes: #674779)

 -- D Haley <mycae@yahoo.com>  Tue, 17 Jun 2012 04:34:32 +1000

libstxxl (1.3.1-3) unstable; urgency=low

  * Team upload.
  * Fix build failure with GCC 4.7, thanks to Matthias Klose (Closes: #672055)
  * Bump standards version to 3.9.3
  * Remove useless quilt references in debian/control & debian/rules.
  * Remove duplicate section in debian/control.

 -- Dmitrijs Ledkovs <xnox@debian.org>  Sun, 27 May 2012 14:44:51 +0100

libstxxl (1.3.1-2) unstable; urgency=low

  * Team upload
  * Standards-Version updated to version 3.9.2
  * Remove lintian warning copyright-has-url-from-dh_make-boilerplate

  [ D Haley ]
  * Import rules include dir fix from 1.3.0-x series. (Closes: #619386)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 18 Feb 2012 15:36:02 +0100

libstxxl (1.3.1-1) unstable; urgency=low

  * New upstream release
  * Add doxygen-latex build-dep (Closes: #616262) 
  
  [ Sylvestre Ledru ]
  * Remove myself from the uploaders
  * Switch to dpkg-source 3.0 (quilt) format

 -- D Haley <mycae@yahoo.com>  Mon, 11 Apr 2011 00:40:06 +0100

libstxxl (1.3.0-1) unstable; urgency=low

  * New upstream release

 -- D Haley <mycae@yahoo.com>  Tue, 10 Aug 2010 03:18:56 +1000

libstxxl (1.2.1-3) unstable; urgency=low

  * Standards-Version updated to version 3.8.4

  [ D Haley ]
  * Remove floatflt from tutorial latex file, as it is no longer in texlive
  * Added more files to clean.

 -- Sylvestre Ledru <sylvestre@debian.org>  Wed, 10 Feb 2010 09:59:38 +0100

libstxxl (1.2.1-2) unstable; urgency=low

  [ D Haley ]
  * Correct copyright field in debian/copyright

  [ Sylvestre Ledru ]
  * Add myself to the uploader (which I should have been done since the first
    release)
 
 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 09 Jan 2010 11:27:08 +0100

libstxxl (1.2.1-1) unstable; urgency=low

  * Initial release (Closes: #540513) 

 -- D Haley <mycae@yahoo.com>  Sat, 29 Aug 2009 20:12:15 +1000

=== debian/control ===
Source: libstxxl
Section: science
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: D Haley <mycae@gmx.com>
Vcs-Git: git://git.debian.org/git/debian-science/packages/libstxxl1.git
Vcs-Browser: http://git.debian.org/?p=debian-science/packages/libstxxl1.git
Build-Depends: debhelper (>= 7), doxygen, doxygen-latex, texlive-fonts-extra, cdbs,
 texlive-latex-extra, graphviz, texlive-latex-recommended,
 texlive-fonts-recommended, ghostscript
Standards-Version: 3.9.4
Homepage: http://stxxl.sourceforge.net

Package: libstxxl1
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: C++ STL drop-in replacement for extremely large datasets
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.

Package: libstxxl-dev
Section: libdevel
Priority: extra
Depends: libstxxl1 (= ${binary:Version}), ${misc:Depends}
Suggests: libstxxl-doc
Architecture: any
Description: Development libraries for STXXL
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
 .
 Development libraries for STXXL, required for building programs that
 utilise the STXXL library

Package: libstxxl-doc
Section: doc
Priority: extra
Depends: ${misc:Depends}
Architecture: all
Description: Documentation for STXXL
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
 . 
 Documentation for the STXXL library.

Package: libstxxl1-dbg
Section: debug
Priority: extra
Depends: libstxxl1 (= ${binary:Version}), ${misc:Depends}
Architecture: any
Description: Debugging symbols for STXXL libraries
 STXXL provides an STL replacement using an abstraction layer to
 storage devices to allow for the optimal layout of data structures. This
 allows for multi-terabyte datasets to be held and manipulated in standard
 C++ data structures, whilst abstracting the complexity of managing this
 behaviour efficiently. STXXL utilises multi-disk I/O to speed up
 I/O bound calculations. STXXL has been developed at the University
 of Karlsruhe.
 .
 Debugging symbols for STXXL, required for debugging programs that
 utilise the STXXL library

=== debian/rules ===
#!/usr/bin/make -f
include /usr/share/cdbs/1/rules/debhelper.mk
include /usr/share/cdbs/1/class/makefile.mk

DEB_MAKE_BUILD_TARGET := library_g++
STXXL_MAJOR=1

configure/libstxxl-dev::
	echo "OPT=-fPIC" > make.settings.local
	echo DEBUG=-g >> make.settings.local

build/libstxxl-doc::
	#Build doxygen stuff
	$(MAKE) doxy
	#Build tutorial
	cd doc/tutorial && $(MAKE)

install/libstxxl1::
	cd lib; \
	if test ! -f libstxxl.so.${DEB_UPSTREAM_VERSION}; then \
	mv libstxxl.so libstxxl.so.${DEB_UPSTREAM_VERSION}; \
	ln -s libstxxl.so.${DEB_UPSTREAM_VERSION} libstxxl.so.$(STXXL_MAJOR); \
	ln -s libstxxl.so.${DEB_UPSTREAM_VERSION} libstxxl.so; \
	fi

binary/libstxxl1::
	#Fix header directory problem 
	mv $(CURDIR)/debian/libstxxl-dev/usr/include/include/* $(CURDIR)/debian/libstxxl-dev/usr/include/
	rmdir  $(CURDIR)/debian/libstxxl-dev/usr/include/include/
	#Fix ICPC workaround which generates conflict with other package
	rm $(CURDIR)/debian/libstxxl-dev/usr/include/bits/intel_compatibility.h
	rmdir $(CURDIR)/debian/libstxxl-dev/usr/include/bits
	#Remove duplicated changelog
	-rm $(CURDIR)/debian/libstxxl1/usr/share/doc/libstxxl1/CHANGELOG.gz

clean::
	-cd lib; \
	rm -f libstxxl.so*
	-rm -f common/stxxl_info.stxxl.bin
	-rm -rf doc/doxy/
	-rm -f 	doc/tutorial/allmakros.aux
	-rm -f 	doc/tutorial/tutorial.aux
	-rm -f 	doc/tutorial/tutorial.bbl
	-rm -f 	doc/tutorial/tutorial.blg
	-rm -f 	doc/tutorial/tutorial.dvi
	-rm -f 	doc/tutorial/tutorial.idx
	-rm -f 	doc/tutorial/tutorial.log
	-rm -f 	doc/tutorial/tutorial.pdf
	-rm -f 	doc/tutorial/tutorial.toc
	-rm -f 	make.settings
	-rm -f 	make.settings.local
	-rm -f log

=== debian/tests/control ===
Tests: unittests
Depends: libstxxl-dev, g++

=== debian/watch ===
# Compulsory line, this is a version 3 file
version=3
 http://sf.net/stxxl/stxxl-(.+)\.tar\.gz
